diff --git a/arch/mips/Kconfig b/arch/mips/Kconfig
index 6a6d2e2..738863fc 100644
--- a/arch/mips/Kconfig
+++ b/arch/mips/Kconfig
@@ -437,6 +437,7 @@ config LANTIQ
 	select PINCTRL_LANTIQ
 	select ARCH_HAS_RESET_CONTROLLER
 	select RESET_CONTROLLER
+	select HAVE_MACH_HEAD_FILES
 
 config LASAT
 	bool "LASAT Networks platforms"
diff --git a/arch/mips/lantiq/Platform b/arch/mips/lantiq/Platform
index b3ec498..3434d85 100644
--- a/arch/mips/lantiq/Platform
+++ b/arch/mips/lantiq/Platform
@@ -3,7 +3,6 @@
 #
 
 platform-$(CONFIG_LANTIQ)	+= lantiq/
-cflags-$(CONFIG_LANTIQ)		+= -I$(srctree)/arch/mips/include/asm/mach-lantiq
 load-$(CONFIG_LANTIQ)		= 0xffffffff80002000
-cflags-$(CONFIG_SOC_TYPE_XWAY)	+= -I$(srctree)/arch/mips/include/asm/mach-lantiq/xway
-cflags-$(CONFIG_SOC_FALCON)	+= -I$(srctree)/arch/mips/include/asm/mach-lantiq/falcon
+cflags-$(CONFIG_SOC_TYPE_XWAY)	+= -I$(srctree)/arch/mips/lantiq/xway/include
+cflags-$(CONFIG_SOC_FALCON)	+= -I$(srctree)/arch/mips/lantiq/falcon/include
diff --git a/arch/mips/lantiq/clk.c b/arch/mips/lantiq/clk.c
index dd819e3..8c715fb 100644
--- a/arch/mips/lantiq/clk.c
+++ b/arch/mips/lantiq/clk.c
@@ -18,7 +18,7 @@
 #include <asm/irq.h>
 #include <asm/div64.h>
 
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 
 #include "clk.h"
 #include "prom.h"
diff --git a/arch/mips/lantiq/early_printk.c b/arch/mips/lantiq/early_printk.c
index 4e4a28b..94c8641 100644
--- a/arch/mips/lantiq/early_printk.c
+++ b/arch/mips/lantiq/early_printk.c
@@ -5,7 +5,7 @@
  */
 
 #include <linux/cpu.h>
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 #include <asm/setup.h>
 
 #define ASC_BUF		1024
diff --git a/arch/mips/include/asm/mach-lantiq/falcon/cpu-feature-overrides.h b/arch/mips/lantiq/falcon/include/mach/cpu-feature-overrides.h
similarity index 100%
rename from arch/mips/include/asm/mach-lantiq/falcon/cpu-feature-overrides.h
rename to arch/mips/lantiq/falcon/include/mach/cpu-feature-overrides.h
diff --git a/arch/mips/include/asm/mach-lantiq/falcon/falcon_irq.h b/arch/mips/lantiq/falcon/include/mach/falcon_irq.h
similarity index 100%
rename from arch/mips/include/asm/mach-lantiq/falcon/falcon_irq.h
rename to arch/mips/lantiq/falcon/include/mach/falcon_irq.h
diff --git a/arch/mips/lantiq/falcon/include/mach/ioremap.h b/arch/mips/lantiq/falcon/include/mach/ioremap.h
new file mode 100644
index 0000000..2369393
--- /dev/null
+++ b/arch/mips/lantiq/falcon/include/mach/ioremap.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/ioremap.h>
diff --git a/arch/mips/include/asm/mach-lantiq/falcon/irq.h b/arch/mips/lantiq/falcon/include/mach/irq.h
similarity index 100%
rename from arch/mips/include/asm/mach-lantiq/falcon/irq.h
rename to arch/mips/lantiq/falcon/include/mach/irq.h
diff --git a/arch/mips/lantiq/falcon/include/mach/kernel-entry-init.h b/arch/mips/lantiq/falcon/include/mach/kernel-entry-init.h
new file mode 100644
index 0000000..19b872be
--- /dev/null
+++ b/arch/mips/lantiq/falcon/include/mach/kernel-entry-init.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/kernel-entry-init.h>
diff --git a/arch/mips/lantiq/falcon/include/mach/kmalloc.h b/arch/mips/lantiq/falcon/include/mach/kmalloc.h
new file mode 100644
index 0000000..4f056db
--- /dev/null
+++ b/arch/mips/lantiq/falcon/include/mach/kmalloc.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/kmalloc.h>
diff --git a/arch/mips/include/asm/mach-lantiq/lantiq.h b/arch/mips/lantiq/falcon/include/mach/lantiq.h
similarity index 100%
copy from arch/mips/include/asm/mach-lantiq/lantiq.h
copy to arch/mips/lantiq/falcon/include/mach/lantiq.h
diff --git a/arch/mips/include/asm/mach-lantiq/lantiq_platform.h b/arch/mips/lantiq/falcon/include/mach/lantiq_platform.h
similarity index 100%
copy from arch/mips/include/asm/mach-lantiq/lantiq_platform.h
copy to arch/mips/lantiq/falcon/include/mach/lantiq_platform.h
diff --git a/arch/mips/include/asm/mach-lantiq/falcon/lantiq_soc.h b/arch/mips/lantiq/falcon/include/mach/lantiq_soc.h
similarity index 100%
rename from arch/mips/include/asm/mach-lantiq/falcon/lantiq_soc.h
rename to arch/mips/lantiq/falcon/include/mach/lantiq_soc.h
diff --git a/arch/mips/lantiq/falcon/include/mach/mangle-port.h b/arch/mips/lantiq/falcon/include/mach/mangle-port.h
new file mode 100644
index 0000000..b9736e3
--- /dev/null
+++ b/arch/mips/lantiq/falcon/include/mach/mangle-port.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/mangle-port.h>
diff --git a/arch/mips/lantiq/falcon/include/mach/mc146818rtc.h b/arch/mips/lantiq/falcon/include/mach/mc146818rtc.h
new file mode 100644
index 0000000..7284af8
--- /dev/null
+++ b/arch/mips/lantiq/falcon/include/mach/mc146818rtc.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/mc146818rtc.h>
diff --git a/arch/mips/lantiq/falcon/include/mach/spaces.h b/arch/mips/lantiq/falcon/include/mach/spaces.h
new file mode 100644
index 0000000..39a4d72
--- /dev/null
+++ b/arch/mips/lantiq/falcon/include/mach/spaces.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/spaces.h>
diff --git a/arch/mips/lantiq/falcon/include/mach/topology.h b/arch/mips/lantiq/falcon/include/mach/topology.h
new file mode 100644
index 0000000..86e585b
--- /dev/null
+++ b/arch/mips/lantiq/falcon/include/mach/topology.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/topology.h>
diff --git a/arch/mips/lantiq/falcon/include/mach/war.h b/arch/mips/lantiq/falcon/include/mach/war.h
new file mode 100644
index 0000000..5b0422a
--- /dev/null
+++ b/arch/mips/lantiq/falcon/include/mach/war.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/war.h>
diff --git a/arch/mips/lantiq/falcon/prom.c b/arch/mips/lantiq/falcon/prom.c
index 7b98def..7df6fd4 100644
--- a/arch/mips/lantiq/falcon/prom.c
+++ b/arch/mips/lantiq/falcon/prom.c
@@ -10,7 +10,7 @@
 #include <asm/traps.h>
 #include <asm/io.h>
 
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 
 #include "../prom.h"
 
diff --git a/arch/mips/lantiq/falcon/reset.c b/arch/mips/lantiq/falcon/reset.c
index 261996c..e9a3048 100644
--- a/arch/mips/lantiq/falcon/reset.c
+++ b/arch/mips/lantiq/falcon/reset.c
@@ -11,7 +11,7 @@
 #include <asm/reboot.h>
 #include <linux/export.h>
 
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 
 /*
  * Dummy implementation.  Used to allow platform code to find out what
diff --git a/arch/mips/lantiq/falcon/sysctrl.c b/arch/mips/lantiq/falcon/sysctrl.c
index 42222f8..0c6e1c1 100644
--- a/arch/mips/lantiq/falcon/sysctrl.c
+++ b/arch/mips/lantiq/falcon/sysctrl.c
@@ -11,7 +11,7 @@
 #include <linux/of_address.h>
 #include <asm/delay.h>
 
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 
 #include "../clk.h"
 
diff --git a/arch/mips/lantiq/irq.c b/arch/mips/lantiq/irq.c
index df8eed3..934d773 100644
--- a/arch/mips/lantiq/irq.c
+++ b/arch/mips/lantiq/irq.c
@@ -16,8 +16,8 @@
 #include <asm/bootinfo.h>
 #include <asm/irq_cpu.h>
 
-#include <lantiq_soc.h>
-#include <irq.h>
+#include <mach/lantiq_soc.h>
+#include <mach/irq.h>
 
 /* register definitions - internal irqs */
 #define LTQ_ICU_ISR		0x0000
diff --git a/arch/mips/lantiq/prom.c b/arch/mips/lantiq/prom.c
index 51a218f..e40e781 100644
--- a/arch/mips/lantiq/prom.c
+++ b/arch/mips/lantiq/prom.c
@@ -13,7 +13,7 @@
 #include <asm/time.h>
 #include <asm/prom.h>
 
-#include <lantiq.h>
+#include <mach/lantiq.h>
 
 #include "prom.h"
 #include "clk.h"
diff --git a/arch/mips/lantiq/xway/clk.c b/arch/mips/lantiq/xway/clk.c
index 47ad214..b5f93e9 100644
--- a/arch/mips/lantiq/xway/clk.c
+++ b/arch/mips/lantiq/xway/clk.c
@@ -13,7 +13,7 @@
 #include <asm/irq.h>
 #include <asm/div64.h>
 
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 
 #include "../clk.h"
 
diff --git a/arch/mips/lantiq/xway/dcdc.c b/arch/mips/lantiq/xway/dcdc.c
index 4960bee..65b3d9b 100644
--- a/arch/mips/lantiq/xway/dcdc.c
+++ b/arch/mips/lantiq/xway/dcdc.c
@@ -8,7 +8,7 @@
 #include <linux/ioport.h>
 #include <linux/of_platform.h>
 
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 
 /* Bias and regulator Setup Register */
 #define DCDC_BIAS_VREG0	0xa
diff --git a/arch/mips/lantiq/xway/dma.c b/arch/mips/lantiq/xway/dma.c
index aeb1b98..1e66592 100644
--- a/arch/mips/lantiq/xway/dma.c
+++ b/arch/mips/lantiq/xway/dma.c
@@ -13,8 +13,8 @@
 #include <linux/clk.h>
 #include <linux/err.h>
 
-#include <lantiq_soc.h>
-#include <xway_dma.h>
+#include <mach/lantiq_soc.h>
+#include <mach/xway_dma.h>
 
 #define LTQ_DMA_ID		0x08
 #define LTQ_DMA_CTRL		0x10
diff --git a/arch/mips/lantiq/xway/gptu.c b/arch/mips/lantiq/xway/gptu.c
index 3d5683e..f57f6f3 100644
--- a/arch/mips/lantiq/xway/gptu.c
+++ b/arch/mips/lantiq/xway/gptu.c
@@ -11,7 +11,7 @@
 #include <linux/of_platform.h>
 #include <linux/of_irq.h>
 
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 #include "../clk.h"
 
 /* the magic ID byte of the core */
diff --git a/arch/mips/lantiq/xway/include/mach/cpu-feature-overrides.h b/arch/mips/lantiq/xway/include/mach/cpu-feature-overrides.h
new file mode 100644
index 0000000..f3e0e12
--- /dev/null
+++ b/arch/mips/lantiq/xway/include/mach/cpu-feature-overrides.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/cpu-feature-overrides.h>
diff --git a/arch/mips/lantiq/xway/include/mach/ioremap.h b/arch/mips/lantiq/xway/include/mach/ioremap.h
new file mode 100644
index 0000000..2369393
--- /dev/null
+++ b/arch/mips/lantiq/xway/include/mach/ioremap.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/ioremap.h>
diff --git a/arch/mips/include/asm/mach-lantiq/xway/irq.h b/arch/mips/lantiq/xway/include/mach/irq.h
similarity index 88%
rename from arch/mips/include/asm/mach-lantiq/xway/irq.h
rename to arch/mips/lantiq/xway/include/mach/irq.h
index 2980e77..6b1e6e4 100644
--- a/arch/mips/include/asm/mach-lantiq/xway/irq.h
+++ b/arch/mips/lantiq/xway/include/mach/irq.h
@@ -7,7 +7,7 @@
 #ifndef __LANTIQ_IRQ_H
 #define __LANTIQ_IRQ_H
 
-#include <lantiq_irq.h>
+#include <mach/lantiq_irq.h>
 
 #define NR_IRQS 256
 
diff --git a/arch/mips/lantiq/xway/include/mach/kernel-entry-init.h b/arch/mips/lantiq/xway/include/mach/kernel-entry-init.h
new file mode 100644
index 0000000..19b872be
--- /dev/null
+++ b/arch/mips/lantiq/xway/include/mach/kernel-entry-init.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/kernel-entry-init.h>
diff --git a/arch/mips/lantiq/xway/include/mach/kmalloc.h b/arch/mips/lantiq/xway/include/mach/kmalloc.h
new file mode 100644
index 0000000..4f056db
--- /dev/null
+++ b/arch/mips/lantiq/xway/include/mach/kmalloc.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/kmalloc.h>
diff --git a/arch/mips/include/asm/mach-lantiq/lantiq.h b/arch/mips/lantiq/xway/include/mach/lantiq.h
similarity index 100%
rename from arch/mips/include/asm/mach-lantiq/lantiq.h
rename to arch/mips/lantiq/xway/include/mach/lantiq.h
diff --git a/arch/mips/include/asm/mach-lantiq/xway/lantiq_irq.h b/arch/mips/lantiq/xway/include/mach/lantiq_irq.h
similarity index 100%
rename from arch/mips/include/asm/mach-lantiq/xway/lantiq_irq.h
rename to arch/mips/lantiq/xway/include/mach/lantiq_irq.h
diff --git a/arch/mips/include/asm/mach-lantiq/lantiq_platform.h b/arch/mips/lantiq/xway/include/mach/lantiq_platform.h
similarity index 100%
rename from arch/mips/include/asm/mach-lantiq/lantiq_platform.h
rename to arch/mips/lantiq/xway/include/mach/lantiq_platform.h
diff --git a/arch/mips/include/asm/mach-lantiq/xway/lantiq_soc.h b/arch/mips/lantiq/xway/include/mach/lantiq_soc.h
similarity index 99%
rename from arch/mips/include/asm/mach-lantiq/xway/lantiq_soc.h
rename to arch/mips/lantiq/xway/include/mach/lantiq_soc.h
index 4790cfa..45ad252 100644
--- a/arch/mips/include/asm/mach-lantiq/xway/lantiq_soc.h
+++ b/arch/mips/lantiq/xway/include/mach/lantiq_soc.h
@@ -9,7 +9,7 @@
 
 #ifdef CONFIG_SOC_TYPE_XWAY
 
-#include <lantiq.h>
+#include <mach/lantiq.h>
 
 /* Chip IDs */
 #define SOC_ID_DANUBE1		0x129
diff --git a/arch/mips/lantiq/xway/include/mach/mangle-port.h b/arch/mips/lantiq/xway/include/mach/mangle-port.h
new file mode 100644
index 0000000..b9736e3
--- /dev/null
+++ b/arch/mips/lantiq/xway/include/mach/mangle-port.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/mangle-port.h>
diff --git a/arch/mips/lantiq/xway/include/mach/mc146818rtc.h b/arch/mips/lantiq/xway/include/mach/mc146818rtc.h
new file mode 100644
index 0000000..7284af8
--- /dev/null
+++ b/arch/mips/lantiq/xway/include/mach/mc146818rtc.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/mc146818rtc.h>
diff --git a/arch/mips/lantiq/xway/include/mach/spaces.h b/arch/mips/lantiq/xway/include/mach/spaces.h
new file mode 100644
index 0000000..39a4d72
--- /dev/null
+++ b/arch/mips/lantiq/xway/include/mach/spaces.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/spaces.h>
diff --git a/arch/mips/lantiq/xway/include/mach/topology.h b/arch/mips/lantiq/xway/include/mach/topology.h
new file mode 100644
index 0000000..86e585b
--- /dev/null
+++ b/arch/mips/lantiq/xway/include/mach/topology.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/topology.h>
diff --git a/arch/mips/lantiq/xway/include/mach/war.h b/arch/mips/lantiq/xway/include/mach/war.h
new file mode 100644
index 0000000..5b0422a
--- /dev/null
+++ b/arch/mips/lantiq/xway/include/mach/war.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/war.h>
diff --git a/arch/mips/include/asm/mach-lantiq/xway/xway_dma.h b/arch/mips/lantiq/xway/include/mach/xway_dma.h
similarity index 100%
rename from arch/mips/include/asm/mach-lantiq/xway/xway_dma.h
rename to arch/mips/lantiq/xway/include/mach/xway_dma.h
diff --git a/arch/mips/lantiq/xway/prom.c b/arch/mips/lantiq/xway/prom.c
index 5446197..33166ae 100644
--- a/arch/mips/lantiq/xway/prom.c
+++ b/arch/mips/lantiq/xway/prom.c
@@ -10,7 +10,7 @@
 #include <asm/bootinfo.h>
 #include <asm/time.h>
 
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 
 #include "../prom.h"
 
diff --git a/arch/mips/lantiq/xway/sysctrl.c b/arch/mips/lantiq/xway/sysctrl.c
index aa37545..3aec430 100644
--- a/arch/mips/lantiq/xway/sysctrl.c
+++ b/arch/mips/lantiq/xway/sysctrl.c
@@ -13,7 +13,7 @@
 #include <linux/of_platform.h>
 #include <linux/of_address.h>
 
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 
 #include "../clk.h"
 #include "../prom.h"
diff --git a/arch/mips/lantiq/xway/vmmc.c b/arch/mips/lantiq/xway/vmmc.c
index 7a14da8..9f64e0b 100644
--- a/arch/mips/lantiq/xway/vmmc.c
+++ b/arch/mips/lantiq/xway/vmmc.c
@@ -9,7 +9,7 @@
 #include <linux/of_gpio.h>
 #include <linux/dma-mapping.h>
 
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 
 static unsigned int *cp1_base;
 
diff --git a/arch/mips/pci/ops-lantiq.c b/arch/mips/pci/ops-lantiq.c
index 7d71355..f695431 100644
--- a/arch/mips/pci/ops-lantiq.c
+++ b/arch/mips/pci/ops-lantiq.c
@@ -12,7 +12,7 @@
 #include <asm/addrspace.h>
 #include <linux/vmalloc.h>
 
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 
 #include "pci-lantiq.h"
 
diff --git a/arch/mips/pci/pci-lantiq.c b/arch/mips/pci/pci-lantiq.c
index 1ca42f4..c1faecb 100644
--- a/arch/mips/pci/pci-lantiq.c
+++ b/arch/mips/pci/pci-lantiq.c
@@ -19,8 +19,8 @@
 
 #include <asm/addrspace.h>
 
-#include <lantiq_soc.h>
-#include <lantiq_irq.h>
+#include <mach/lantiq_soc.h>
+#include <mach/lantiq_irq.h>
 
 #include "pci-lantiq.h"
 
diff --git a/drivers/gpio/gpio-mm-lantiq.c b/drivers/gpio/gpio-mm-lantiq.c
index f460d71..4e153d3 100644
--- a/drivers/gpio/gpio-mm-lantiq.c
+++ b/drivers/gpio/gpio-mm-lantiq.c
@@ -15,7 +15,7 @@
 #include <linux/io.h>
 #include <linux/slab.h>
 
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 
 /*
  * By attaching hardware latches to the EBU it is possible to create output
diff --git a/drivers/hwmon/ltq-cputemp.c b/drivers/hwmon/ltq-cputemp.c
index 019e770..327c5e1 100644
--- a/drivers/hwmon/ltq-cputemp.c
+++ b/drivers/hwmon/ltq-cputemp.c
@@ -12,7 +12,7 @@
 #include <linux/module.h>
 #include <linux/of_device.h>
 
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 
 /* gphy1 configuration register contains cpu temperature */
 #define CGU_GPHY1_CR   0x0040
diff --git a/drivers/mtd/maps/lantiq-flash.c b/drivers/mtd/maps/lantiq-flash.c
index 67a1dbf..9b0c3a5 100644
--- a/drivers/mtd/maps/lantiq-flash.c
+++ b/drivers/mtd/maps/lantiq-flash.c
@@ -19,7 +19,7 @@
 #include <linux/mtd/physmap.h>
 #include <linux/of.h>
 
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 
 /*
  * The NOR flash is connected to the same external bus unit (EBU) as PCI.
diff --git a/drivers/mtd/nand/raw/xway_nand.c b/drivers/mtd/nand/raw/xway_nand.c
index 834f794..5bdeea2 100644
--- a/drivers/mtd/nand/raw/xway_nand.c
+++ b/drivers/mtd/nand/raw/xway_nand.c
@@ -9,7 +9,7 @@
 #include <linux/of_gpio.h>
 #include <linux/of_platform.h>
 
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 
 /* nand registers */
 #define EBU_ADDSEL1		0x24
diff --git a/drivers/net/ethernet/lantiq_etop.c b/drivers/net/ethernet/lantiq_etop.c
index 2d0c52f..bae1c1e 100644
--- a/drivers/net/ethernet/lantiq_etop.c
+++ b/drivers/net/ethernet/lantiq_etop.c
@@ -28,9 +28,9 @@
 
 #include <asm/checksum.h>
 
-#include <lantiq_soc.h>
-#include <xway_dma.h>
-#include <lantiq_platform.h>
+#include <mach/lantiq_soc.h>
+#include <mach/xway_dma.h>
+#include <mach/lantiq_platform.h>
 
 #define LTQ_ETOP_MDIO		0x11804
 #define MDIO_REQUEST		0x80000000
diff --git a/drivers/pinctrl/pinctrl-falcon.c b/drivers/pinctrl/pinctrl-falcon.c
index a454f57..f7e66b1 100644
--- a/drivers/pinctrl/pinctrl-falcon.c
+++ b/drivers/pinctrl/pinctrl-falcon.c
@@ -21,7 +21,7 @@
 
 #include "pinctrl-lantiq.h"
 
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 
 /* Multiplexer Control Register */
 #define LTQ_PADC_MUX(x)         (x * 0x4)
diff --git a/drivers/pinctrl/pinctrl-xway.c b/drivers/pinctrl/pinctrl-xway.c
index 5e3f31b..cb7f92e 100644
--- a/drivers/pinctrl/pinctrl-xway.c
+++ b/drivers/pinctrl/pinctrl-xway.c
@@ -20,7 +20,7 @@
 
 #include "pinctrl-lantiq.h"
 
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 
 /* we have up to 4 banks of 16 bit each */
 #define PINS			16
diff --git a/drivers/soc/lantiq/fpi-bus.c b/drivers/soc/lantiq/fpi-bus.c
index dff1375..1d3f3d7 100644
--- a/drivers/soc/lantiq/fpi-bus.c
+++ b/drivers/soc/lantiq/fpi-bus.c
@@ -16,7 +16,7 @@
 #include <linux/property.h>
 #include <linux/regmap.h>
 
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 
 #define XBAR_ALWAYS_LAST	0x430
 #define XBAR_FPI_BURST_EN	BIT(1)
diff --git a/drivers/spi/spi-falcon.c b/drivers/spi/spi-falcon.c
index d3336a6..572b01d 100644
--- a/drivers/spi/spi-falcon.c
+++ b/drivers/spi/spi-falcon.c
@@ -12,7 +12,7 @@
 #include <linux/of.h>
 #include <linux/of_platform.h>
 
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 
 #define DRV_NAME		"sflash-falcon"
 
diff --git a/drivers/spi/spi-lantiq-ssc.c b/drivers/spi/spi-lantiq-ssc.c
index 1fd7ee5..ad3c0b4 100644
--- a/drivers/spi/spi-lantiq-ssc.c
+++ b/drivers/spi/spi-lantiq-ssc.c
@@ -20,7 +20,7 @@
 #include <linux/spi/spi.h>
 
 #ifdef CONFIG_LANTIQ
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 #endif
 
 #define LTQ_SPI_RX_IRQ_NAME	"spi_rx"
diff --git a/drivers/watchdog/lantiq_wdt.c b/drivers/watchdog/lantiq_wdt.c
index 6fab504..f9c1850 100644
--- a/drivers/watchdog/lantiq_wdt.c
+++ b/drivers/watchdog/lantiq_wdt.c
@@ -16,7 +16,7 @@
 #include <linux/regmap.h>
 #include <linux/mfd/syscon.h>
 
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 
 #define LTQ_XRX_RCU_RST_STAT		0x0014
 #define LTQ_XRX_RCU_RST_STAT_WDT	BIT(31)
diff --git a/include/linux/lantiq.h b/include/linux/lantiq.h
index 6792116..1a9103f 100644
--- a/include/linux/lantiq.h
+++ b/include/linux/lantiq.h
@@ -4,7 +4,7 @@
 #define __LINUX_LANTIQ_H
 
 #ifdef CONFIG_LANTIQ
-#include <lantiq_soc.h>
+#include <mach/lantiq_soc.h>
 #else
 
 #ifndef LTQ_EARLY_ASC