diff --git a/arch/mips/Kconfig b/arch/mips/Kconfig
index ce1b5e3..f5f144f 100644
--- a/arch/mips/Kconfig
+++ b/arch/mips/Kconfig
@@ -541,6 +541,7 @@ config MACH_PISTACHIO
 	select SYS_HAS_EARLY_PRINTK
 	select USE_GENERIC_EARLY_PRINTK_8250
 	select USE_OF
+	select HAVE_MACH_HEAD_FILES
 	help
 	  This enables support for the IMG Pistachio SoC platform.
 
diff --git a/arch/mips/include/asm/eva.h b/arch/mips/include/asm/eva.h
index a3d1807..45034a5 100644
--- a/arch/mips/include/asm/eva.h
+++ b/arch/mips/include/asm/eva.h
@@ -11,7 +11,7 @@
 #ifndef _ASM_EVA_H
 #define _ASM_EVA_H
 
-#include <kernel-entry-init.h>
+#include <mach/kernel-entry-init.h>
 
 #ifdef __ASSEMBLY__
 
diff --git a/arch/mips/pistachio/Platform b/arch/mips/pistachio/Platform
index c3592b37..22580e9 100644
--- a/arch/mips/pistachio/Platform
+++ b/arch/mips/pistachio/Platform
@@ -3,7 +3,7 @@
 #
 platform-$(CONFIG_MACH_PISTACHIO)	+= pistachio/
 cflags-$(CONFIG_MACH_PISTACHIO)		+=				\
-		-I$(srctree)/arch/mips/include/asm/mach-pistachio
+		-I$(srctree)/arch/mips/pistachio/include
 load-$(CONFIG_MACH_PISTACHIO)		+= 0xffffffff80400000
 zload-$(CONFIG_MACH_PISTACHIO)		+= 0xffffffff81000000
 all-$(CONFIG_MACH_PISTACHIO)		:= uImage.gz
diff --git a/arch/mips/pistachio/include/mach/cpu-feature-overrides.h b/arch/mips/pistachio/include/mach/cpu-feature-overrides.h
new file mode 100644
index 0000000..f3e0e12
--- /dev/null
+++ b/arch/mips/pistachio/include/mach/cpu-feature-overrides.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/cpu-feature-overrides.h>
diff --git a/arch/mips/pistachio/include/mach/ioremap.h b/arch/mips/pistachio/include/mach/ioremap.h
new file mode 100644
index 0000000..2369393
--- /dev/null
+++ b/arch/mips/pistachio/include/mach/ioremap.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/ioremap.h>
diff --git a/arch/mips/include/asm/mach-pistachio/irq.h b/arch/mips/pistachio/include/mach/irq.h
similarity index 100%
rename from arch/mips/include/asm/mach-pistachio/irq.h
rename to arch/mips/pistachio/include/mach/irq.h
diff --git a/arch/mips/pistachio/include/mach/kernel-entry-init.h b/arch/mips/pistachio/include/mach/kernel-entry-init.h
new file mode 100644
index 0000000..19b872be
--- /dev/null
+++ b/arch/mips/pistachio/include/mach/kernel-entry-init.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/kernel-entry-init.h>
diff --git a/arch/mips/pistachio/include/mach/kmalloc.h b/arch/mips/pistachio/include/mach/kmalloc.h
new file mode 100644
index 0000000..4f056db
--- /dev/null
+++ b/arch/mips/pistachio/include/mach/kmalloc.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/kmalloc.h>
diff --git a/arch/mips/pistachio/include/mach/mangle-port.h b/arch/mips/pistachio/include/mach/mangle-port.h
new file mode 100644
index 0000000..b9736e3
--- /dev/null
+++ b/arch/mips/pistachio/include/mach/mangle-port.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/mangle-port.h>
diff --git a/arch/mips/pistachio/include/mach/mc146818rtc.h b/arch/mips/pistachio/include/mach/mc146818rtc.h
new file mode 100644
index 0000000..7284af8
--- /dev/null
+++ b/arch/mips/pistachio/include/mach/mc146818rtc.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/mc146818rtc.h>
diff --git a/arch/mips/pistachio/include/mach/spaces.h b/arch/mips/pistachio/include/mach/spaces.h
new file mode 100644
index 0000000..39a4d72
--- /dev/null
+++ b/arch/mips/pistachio/include/mach/spaces.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/spaces.h>
diff --git a/arch/mips/pistachio/include/mach/topology.h b/arch/mips/pistachio/include/mach/topology.h
new file mode 100644
index 0000000..86e585b
--- /dev/null
+++ b/arch/mips/pistachio/include/mach/topology.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/topology.h>
diff --git a/arch/mips/pistachio/include/mach/war.h b/arch/mips/pistachio/include/mach/war.h
new file mode 100644
index 0000000..5b0422a
--- /dev/null
+++ b/arch/mips/pistachio/include/mach/war.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/war.h>